<template>
  <div class="auth">
    <div class="q-pa-md text-h5 mx-auto my-6 sm:1/4 w-1/2">Аутентификация</div>
    <q-card class="q-pa-md mx-auto my-6 sm:w-1/2 w-full">
      <q-form
        @submit="onsubmit"
        @reset="onReset"
        class="q-gutter-md"
      >
        <q-input
          filled
          v-model="email"
          label="Email"
          hint="Ваш Email"
          lazy-rules
          :rules="[ val => val && val.length > 0 || 'Введите email']"
        />

        <q-input
          filled
          v-model="password"
          label="Пароль"
          lazy-rules
          :rules="[
          val => val !== null && val !== '' || 'Введите пароль',
        ]"
          :type="isPwd ? 'password' : 'text'"
          toggle
        >
          <template v-slot:append>
            <q-icon
              :name="isPwd ? 'visibility_off' : 'visibility'"
              class="cursor-pointer"
              @click="isPwd = !isPwd"
            />
          </template>
        </q-input>

        <div class="float-right">
          <q-btn label="Очистить" type="reset" color="primary" flat class="q-ml-sm mt-10" />
          <q-btn label="Войти" type="submit" class="mt-10" color="primary"/>
        </div>
      </q-form>
    </q-card>
  </div>
</template>

<script>
import { ref } from 'vue'
import {useStore} from "vuex";
import { getAuth, signInWithEmailAndPassword, setPersistence, browserSessionPersistence, } from "firebase/auth";
import {useRouter} from 'vue-router'
export default {
  name: "Auth",
  setup () {
    const store = useStore()
    const router = useRouter()
    const auth = getAuth();
    const email = ref('');
    const password = ref('');
    function onsubmit() {
      setPersistence(auth, browserSessionPersistence)
        .then(() => {
          return signInWithEmailAndPassword(auth, email.value, password.value)
            .then((userCredential) => {
              // Signed in
              store.state.user = userCredential.user;
              localStorage.setItem('user', JSON.stringify(userCredential.user))
              router.replace({name: 'Index'})
            })
            .catch((error) => {
              const errorCode = error.code;
              const errorMessage = error.message;
              console.log(errorCode, errorMessage)
            });
        })
        .catch((error) => {
          // Handle Errors here.
          const errorCode = error.code;
          const errorMessage = error.message;
        });
    }
    return {
      email,
      password,
      isPwd: ref(true),
      onsubmit,
      onReset() {
        email.value = ''
        password.value = ''
      }
    }
  }
}
</script>

<style scoped lang="scss">
.auth {
}
</style>
